<template>
    <tr>
        <td class="w-16">
            <input
                type="checkbox"
                class="checkbox"
                :value="priceListItem.id"
                v-model="priceListItem.selected"
            >
        </td>
        <td>
            <div class="text-left" >
                <span class="whitespace-no-wrap">
                    {{ priceListItemName }}
                </span>
            </div>
        </td>
        <td>
            <div class="text-left" >
                <span class="whitespace-no-wrap">
                    {{ priceListItem.nail_weight_1000 }}
                </span>
            </div>
        </td>
        <td>
            <div class="text-left" >
                <input
                    @input="$emit('input', priceListItem)"
                    v-model="priceListItem.wire_price"
                    class="form-control form-input form-input-bordered w-40"
                    type="number"
                    step="1"
                    min="0"
                    :readonly="readonly"
                >
            </div>
        </td>
        <td v-show="priceListType=='welded'">
            <div class="text-left" >
                <input
                    @input="$emit('input',priceListItem)"
                    v-model="priceListItem.nail_price_coefficient"
                    class="form-control form-input form-input-bordered w-40"
                    type="number"
                    step="0.01"
                    min="0"
                    :readonly="readonly"
                >
            </div>
        </td>
        <td v-show="priceListType=='loose'">
            <div class="text-left" >
                <input
                    @input="$emit('input',priceListItem)"
                    v-model="priceListItem.nail_price_per_kg_coefficient"
                    class="form-control form-input form-input-bordered w-40"
                    type="number"
                    step="0.01"
                    min="0"
                    :readonly="readonly"
                >
            </div>
        </td>
        <td>
            <div class="text-left" >
                <input
                    @input="$emit('input',priceListItem)"
                    v-model="priceListItem.surcharge"
                    class="form-control form-input form-input-bordered w-40"
                    type="number"
                    step="1"
                    min="0"
                    :readonly="readonly"
                >
            </div>
        </td>
        <td v-show="priceListType=='welded'">
            <div class="text-left" >
                <input
                    @input="$emit('input',priceListItem)"
                    class="form-control form-input form-input-bordered w-40"
                    :value="price_1000"
                    type="number"
                    step="0.0001"
                    readonly="readonly"
                    min="0"
                >
            </div>
        </td>
        <td v-show="priceListType=='loose'">
            <div class="text-left" >
                <input
                    @input="$emit('input',priceListItem)"
                    class="form-control form-input form-input-bordered w-40"
                    :value="price_per_kg"
                    type="number"
                    step="0.0001"
                    readonly="readonly"
                    min="0"
                >
            </div>
        </td>
        <td class="td-fit text-right pr-6 align-middle">
            <div v-if="!readonly" class="inline-flex items-center">
                <button
                    @click="openDeleteDialog()"
                    class="
                        inline-flex
                        appearance-none
                        cursor-pointer
                        text-70
                        hover:text-primary
                        mr-3
                        has-tooltip"
                >
                    <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 20 20" aria-labelledby="delete" role="presentation" class="fill-current">
                    <path fill-rule="nonzero" d="M6 4V2a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v2h5a1 1 0 0 1 0 2h-1v12a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V6H1a1 1 0 1 1 0-2h5zM4 6v12h12V6H4zm8-2V2H8v2h4zM8 8a1 1 0 0 1 1 1v6a1 1 0 0 1-2 0V9a1 1 0 0 1 1-1zm4 0a1 1 0 0 1 1 1v6a1 1 0 0 1-2 0V9a1 1 0 0 1 1-1z"></path>
                    </svg>
                </button>
                <modal v-if="deleteDialogShow" @modal-close="closeDeleteDialog()">
                    <div class="bg-white rounded-lg shadow-lg overflow-hidden text-left" style="">
                            <div class="p-8">
                                <heading :level="2" class="mb-6 text-90 font-normal text-xl">Zmazanie záznamu z cenníka</heading>
                                <div class="text-100 container">
                                    Naozaj chcete zmazať položku <b>{{ priceListItemName }}</b> z cenníka?
                                </div>
                            </div>
                            <div class="bg-30 px-6 py-3 flex">
                                <div class="flex items-center ml-auto">
                                    <button
                                            type="button"
                                            class="btn text-80 font-normal h-9 px-3 mr-3 btn-link"
                                            @click="closeDeleteDialog()"
                                    >
                                        Zrušiť
                                    </button>

                                    <button
                                        type="button"
                                        class="btn btn-default btn-danger"
                                        @click="deleteItem()"
                                    >
                                        Zmazať
                                    </button>
                                </div>
                            </div>

                    </div>
                </modal>
            </div>
        </td>
        </tr>
</template>

<script>
    export default {
        props: {
            value: {},
            readonly: {},
            constants: {},
            priceListType: '',
        },
        data: () => ({
            priceListItem: {},
            deleteDialogShow: false,
        }),
        computed: {
            priceListItemName () {
                return this.priceListItem.wire_average
                    + 'x'
                    + this.priceListItem.nail_length
                    + (this.priceListItem.nail_finish_label?(' ' + this.priceListItem.nail_finish_label) :'')
            },
            price_per_kg () {
                let price = 0

                price = (parseFloat(this.priceListItem.wire_price)/1000) + parseFloat(this.priceListItem.nail_price_per_kg_coefficient);

                let surcharge = parseFloat(this.priceListItem.surcharge)

                if ( surcharge > 0 ) {
                    price = price * ( 1 + ( surcharge / 100 ) )
                }

                price = price.toFixed(2)

                this.priceListItem.price_per_kg = price

                return price
            },
            price_1000 () {
                let price = 0

                price = parseFloat(this.priceListItem.nail_weight_1000)/1000 * parseFloat(this.priceListItem.wire_price) + parseFloat(this.priceListItem.nail_price_coefficient) + parseFloat(this.constants.nailNoFinishCoefficient);

                let surcharge = parseFloat(this.priceListItem.surcharge)

                if ( surcharge > 0 ) {
                    price = price * ( 1 + ( surcharge / 100 ) )
                }

                price = price.toFixed(2)

                this.priceListItem.price_1000 = price

                return price
            }
        },
        methods: {
            openDeleteDialog() {
                this.deleteDialogShow = true
            },
            closeDeleteDialog() {
                this.deleteDialogShow = false
            },
            deleteItem() {
                let config = {
                    data: {
                        priceListItemIds: [this.priceListItem.id]
                    }
                }
                Nova.request().delete('/nova-vendor/price-list-items-form/delete-price-list-item', config)
                    .then(response => {
                        this.closeDeleteDialog()
                        this.$emit('delete-row')
                        console.log(response)
                    })
            }
        },
        mounted() {
            this.priceListItem = this.value
        }
    }
</script>

<style scoped>

</style>